// Data Grid event prototypes

// Click on row
function OnHTMLDataGridRowSelect(cVar, rowData, rowNumber) 
{
   var grid = eval(cVar);
   grid.editRow(rowData, rowNumber);
}

// Click on cell
function OnHTMLDataGridCellSelect(cVar, rowNumber, colNumber) 
{
   var grid = eval(cVar);
   grid.editCell(rowData, rowNumber);
}

// Update data
function OnHTMLDataGridDataChange(cVar) { eval(cVar + ".writeObjHTML()");}

// Support for tracking link clicks
function OnHTMLDataGridLinkClick(hRef)
{
	window.open(hRef);
}

// utility function
function escapeArray ( valArray, valProp )
{
	var valueList = new Array();

   for ( n = 0; n < valArray.length; n++ )
   {
      valueList[n] = (arguments.length == 2) ? escape(eval("valArray[n]." + valProp)) 
                                             : escape(valArray[n]);
   }

   return valueList;
}

// constituent objects
function DGSeries(itemNum, itemHeading, cssStyle)
{
   this.itemNum = itemNum;
   this.itemHeading = itemHeading;
   this.cssStyle = cssStyle;
}

function DGCell(rowNum, colNum, dataType, htmlData, cssStyle)
{
   this.cssStyle = "";
   this.htmlData = "";
   this.dataType = "string";
   this.colNum = 0;
   this.rowNum = 0;
   
   switch (arguments.length)
   {
   case 5:
      this.cssStyle = cssStyle;
   case 4:
      this.htmlData = htmlData;
   case 3:
      this.dataType = "string";
   case 2:
      this.colNum = colNum;
      this.rowNum = rowNum;
   }
}

// Main Data Grid object
function HTMLDataGrid3(controlVariable, frameDiv, initialData)
{
    //  Standard stuff
    this.ctrlVar = controlVariable;
    this.container = frameDiv;
    this.objHTML = buildTable;
    this.writeObjHTML = writeTable;

    //  Display Properties
    this.bShowHeading = false;
    this.bNamedFirstColumn = false;
    this.bNumberRows = true;
	 this.border = 1;

	 // State Properties
	 this.maxRows = 1;
	 this.pages = 1;
	 this.currentPage = 0;
	 this.currentRow = 0;

    // Methods
    this.addRow = addDataRow;
	 this.editRow = editDataRow;
    this.updateRow = updateDataRow;
    this.deleteRow = deleteDataRow;
	 
    this.nextPage = nextDataPage;
	 this.prevPage = prevDataPage;

	 //New Properties
	 this.rowSelect = true;
	 this.colSelect = false;

	 //New Methods
    this.getValue = returnGridValue;
    this.setValue = updateGridValue;
	 this.highlightRow = highlightRow;
	 this.highlightCol = highlightCol;
	 this.highlightCell = highlightCell;
	 this.editCell = editCell;
	 this.catchKeys = catchKeys;

	 // Column Methods
    this.addCol = addDataCol;
	 this.editCol = editDataCol;
    this.updateCol = updateDataCol;
    this.deleteCol = deleteDataCol;

    // Data Mangement
    this.gridCols = new Array();
    this.gridRows = new Array();
    this.arrayData = new Array();
    if (initialData)
    {
       var colcount = 0;
       var rowcount = 0;

       for (var c in initialData)
       {
          this.gridRows[this.gridRows.length] = new DGSeries(this.gridRows.length, "", "");
          this.arrayData[rowcount] = new Array();

          for (var c2 in initialData[c])
          {
             if (colcount > this.gridCols.length)
             {
                this.gridCols[this.gridCols.length] = new DGSeries(this.gridCols.length, "", "");
             }
             
             this.arrayData[rowcount][colcount] = new DGCell(rowcount, colcount, "string", initialData[c][c2], "");
             colcount++;
          }
          colcount = 0;
          rowcount++;
       }
    }
    
    function highlightRow(rowNum)
	 {
		 var gridT = document.all["gridTable"];
		 gridT.rows[rowNum].style.backgroundColor = "red";
	 }

	 function highlightCol(colNum)
	 {
		 var gridT = document.all["gridTable"];

		 for (num = 0; num < gridT.rows.length; num++) 
		 {
			 gridT.rows[num].cells[colNum].style.backgroundColor = "red";
		 }
	 }

	 function highlightCell(rowNum, colNum)
	 {
		 var gridT = document.all["gridTable"];

		 gridT.rows[rowNum].cells[colNum].style.backgroundColor = "red";
	 }
    
	 function returnGridValue(x, y)
    {
       return this.arrayData[x][y].htmlData;   
    }

    function updateGridValue(x, y, newValue)
    {
       this.arrayData[x][y].htmlData = newValue;   
       OnHTMLDataGridDataChange(this.ctrlVar);
    }
	 
	 function editCell(rowNum, colNum)
	 {
		 if (!document.all["editCell"]) 
		 {
			var gridT = document.all["gridTable"];

			gridT.rows[rowNum].cells[colNum].innerHTML = "<input name=editCell id=editCell type=text onkeypress='"
																  + this.ctrlVar 
																  + ".catchKeys(" + rowNum + "," + colNum + ")'"
																  + " value=\"" + unescape(this.arrayData[rowNum][colNum-1].htmlData) + "\">";
		 }

		 document.all["editCell"].focus();
	 }
    
	 function catchKeys(rowNum, colNum)
	 {
 		if (event.keyCode == 13) 
		{
			var gridT = document.all["gridTable"];
			gridT.rows[rowNum].cells[colNum].innerHTML = event.srcElement.value;
			this.arrayData[rowNum-1][colNum-1].htmlData = escape(event.srcElement.value);
		}
	 }

	 function parseLink(lText)
	 {
		if (lText.indexOf("<A") != -1)
		{
			var arLink = lText.split("href=");
			var hrefText = arLink[1].substr(arLink[1].indexOf(" "));
			var lIdx = arLink[1].indexOf(">");
			return "<a href=javascript:OnHTMLDataGridLinkClick('" + hrefText
				    + "')>" + link[1].substring(lIdx);
		}
		else return lText;
	 }

	 function writeTable()
	 {
  		document.all[this.container].innerHTML = this.objHTML();
	 }

    function buildTable()
    {
		 this.pages = Math.ceil(this.arrayData.length / this.maxRows);
		 
		 this.currentPage = Math.max(this.currentPage, 0);
		 this.currentPage = Math.min(this.currentPage, this.pages-1);

		 var numRows = (this.currentPage != this.pages-1) ? this.maxRows :
								         this.gridRows.length % this.maxRows;
       
       if (numRows == 0) numRows = this.maxRows;

       var tableHTML = new String("<TABLE id=gridTable border=" + this.border + ">");
      
		 if (this.bShowHeading)
		 {
			tableHTML += "<tr>";
			if (this.bNumberRows) tableHTML += "<th>#</th>";
			for (i2 = 0; i2 < this.gridCols.length; i2++)
			{
				 tableHTML += "<th>" + this.gridCols[i2].itemHeading + "</th>";
			}
			tableHTML += "</tr>";
		 }
		 
		 if (this.currentRow.length > 0)
		 {
			tableHTML += "<tr>";
			if (this.bNumberRows) tableHTML += "<td>" + this.currentRow[0] + "</td>";
			for (i2 = 1; i2 < this.currentRow.length; i2++)
			{
				 tableHTML += "<td>" + this.currentRow[i2] + "</td>";
			}
			tableHTML += "</tr>";
		 }
		 
		 var startRow = this.maxRows*this.currentPage;

		 for (i = startRow; i < startRow+numRows; i++)
       {
          if (this.arrayData[i].length > 1) {}

			 tableHTML += "<tr onclick=\"OnHTMLDataGridRowSelect('" + this.ctrlVar + "', '" + escapeArray(this.arrayData[i], "htmlData") + "'," + i + ");\">";

			 if (this.bNumberRows) tableHTML += "<td>" + (i+1) + "</td>";

          for (i2 = 0; i2 < this.gridCols.length; i2++)
          {
             tableHTML += "<td onclick=\"OnHTMLDataGridCellSelect('" + this.ctrlVar + "', " + (i-startRow) + ", " + (i2+1) + ")\">" + this.arrayData[i][i2].htmlData + "</td>";
          }

			 tableHTML += "</tr>";
       }

       alert(tableHTML);
		 return tableHTML + "</table>";
    }

    function addDataRow(arRow) 
	 {
  		this.arrayData[this.arrayData.length] = arRow;
		OnHTMLDataGridDataChange(this.ctrlVar);
	 }

	 function editDataRow(rowData, rowNumber)
	 {
       this.currentRow = new Array();

		 arData = rowData.split(",");  
		 this.currentRow[0] = rowNumber;

		 for (x2=0; x2 < arData.length; x2++) 
		 {
          this.currentRow[x2+1] = "<input id=currentRow" + x2 + " value=\"" + unescape(arData[x2]) + "\">";
		 }
		 

       this.currentRow[this.currentRow.length] = "<input type=button id=btnRow value='Update' onclick='" 
			                        + this.ctrlVar + ".updateRow(" + rowNumber + ")'>";
       
       OnHTMLDataGridDataChange(this.ctrlVar);
	 }

    function updateDataRow(rowNumber, arRow) 
	 {
		 if (arguments.length == 1) 
		 {
			 arRow = new Array();
			 var eCount = 0;
  			
			 while (document.all["currentRow" + eCount]) 
			 {
				arRow[eCount] = document.all["currentRow" + eCount].value;
				eCount++;
			 }

			 this.currentRow = new Array();
		 }

		 this.arrayData[rowNumber] = arRow;
		 OnHTMLDataGridDataChange(this.ctrlVar);
	 }

    function deleteDataRow(rowNumber) 
    {
       this.arrayData[this.arrayData.length] = null;
       OnHTMLDataGridDataChange(this.ctrlVar);
    }

    function addDataCol(arCol) 
	 {
  		this.arrayData[this.arrayData.length] = arCol;
		OnHTMLDataGridDataChange(this.ctrlVar);
	 }

	 function editDataCol(ColData, ColNumber)
	 {
       this.currentCol = new Array();

		 arData = ColData.split(",");  
		 this.currentCol[0] = ColNumber;

		 for (x2=0; x2 < arData.length; x2++) 
		 {
          this.currentCol[x2+1] = "<input id=currentCol" + x2 + " value=\"" + unescape(arData[x2]) + "\">";
		 }
		 

       this.currentCol[this.currentCol.length] = "<input type=button id=btnCol value='Update' onclick='" 
			                        + this.ctrlVar + ".updateCol(" + ColNumber + ")'>";
       
       OnHTMLDataGridDataChange(this.ctrlVar);
	 }

    function updateDataCol(ColNumber, arCol) 
	 {
		 if (arguments.length == 1) 
		 {
			 arCol = new Array();
			 var eCount = 0;
  			
			 while (document.all["currentCol" + eCount]) 
			 {
				arCol[eCount] = document.all["currentCol" + eCount].value;
				eCount++;
			 }

			 this.currentCol = new Array();
		 }

		 this.arrayData[ColNumber] = arCol;
		 OnHTMLDataGridDataChange(this.ctrlVar);
	 }

    function deleteDataCol(ColNumber) 
    {
       this.arrayData[this.arrayData.length] = null;
       OnHTMLDataGridDataChange(this.ctrlVar);
    }
	 
    function nextDataPage(z)
	 {
		this.currentPage = (arguments.length == 1) ? z : ++this.currentPage;
		OnHTMLDataGridDataChange(this.ctrlVar);
	 }
	 
	 function prevDataPage(z)
	 {
		 this.currentPage = (arguments.length == 1) ? z : --this.currentPage;
		 OnHTMLDataGridDataChange(this.ctrlVar);
	 }
}
